#ifndef __CANDIDATEWORDLIST_H__
#define __CANDIDATEWORDLIST_H__
#pragma once

//#include <iostream>
#include "CandidateWord.h"


class CCandidateWordList: public CLinkedList
{
private:
	unsigned int	m_CandidateWordID_Counter;

public:
	CCandidateWordList();
	~CCandidateWordList();

	bool Add(CCandidateWord* pData);
	bool Clear();

	void ClearData(ListNode* pNode);
	bool AreDataEqual(void* pDataA, void* pDataB, LLEqualOption nOption);
	int Comparer(void* pDataA, void* pDataB, LLCompareOption nOption);

	CCandidateWord* DumpData(ListNode** pNode);
	void ClearPriorities();

	CCandidateWord* SelectCandidateWord(CPriorityList* pPriorityList, unsigned int uCandidateIndexID, unsigned int uCandidateWordID);
	CCandidateWord*	FindCandidateWordByID(unsigned int in_uID);
	CCandidateWord* SetCandidateWordPriority(unsigned int in_uID, int in_nPriority);
	CCandidateWord*	GetCandidateWordPriority(unsigned int in_uID, int& out_rPriority);


	unsigned int GetCandidateWordIDCounter()
	{
		return m_CandidateWordID_Counter;
	}

	void SetCandidateWordIDCounter(unsigned int uValue)
	{
		m_CandidateWordID_Counter = uValue;
	}
};

#endif
