
#include "PPbopomo.h"

extern void Outdebugstring(char* str);
extern void WOutdebugstring(wchar_t * wstr);

PPbopomo::PPbopomo()
{
	//bopomo
	m_Candidate_count = 0;
	m_pRootString = NULL;
	memset(m_preedit_wstring, 0, sizeof(m_preedit_wstring));
	memset(m_CandicateString, 0, sizeof(m_CandicateString));
	memset(m_PreeditString, 0, sizeof(m_PreeditString));
	m_pCI = NULL;
	m_pCWBuffer = NULL;
}

PPbopomo::~PPbopomo()
{

}

bool PPbopomo::CimConfigure(wchar_t *pRootChar)
{
	CUnicodeStringList StringList;
	size_t n = 0;	
	bool b_ret = false;


	// 1. get available roots.
	m_cim.GetAvailableRoots(pRootChar, true, &StringList);
	
	// 2. get number of available roots.
	n = m_cim.GetCountOfAvailableRoots(&StringList);

	
	if(m_pRootString != NULL)
	{
		delete [] m_pRootString;
		m_pRootString = NULL;
	}
	
		
	if(n > 0)
	{
		m_pRootString = new wchar_t[n+1];	// zero ending string.
		// 3. get wide character array. 		
		m_cim.GetAvailableRootsArray(&StringList, m_pRootString, n+1);
	}

 	m_cim.GetCandidateWordsByRoot(pRootChar, true, &m_pCI);
	size_t count = m_cim.GetCountOfCandidateWords(m_pCI);

	if(count > 0)
	{
		m_pCWBuffer = new CandidateWordBuffer[count];
		if(m_pCWBuffer)
		{
			m_cim.SortCandidateWords(m_pCI, DES_BY_PRIORITY);
			m_cim.GetCandidateWordsArray(m_pCI, m_pCWBuffer, count);
		}

		if(m_pCWBuffer  != NULL)
		{
			memset(m_CandicateString, 0, sizeof(m_CandicateString)); //쥻O m_CandicateString.clear();
			wchar_t wctemp[CANDIDATEWORD_BUFFER_SIZE];

			for(size_t i=0; i<count; i++)
			{			
				//쥻O m_CandicateString.push_back(m_pCWBuffer[i].CandidateWord[0]);
				memset(wctemp, 0, sizeof(wctemp));
				*wctemp = m_pCWBuffer[i].CandidateWord[0];
				wcscat(m_CandicateString, wctemp);
			}
		}
		
		b_ret = true;
	}
	else
	{
		memset(m_CandicateString, 0, sizeof(m_CandicateString)); //쥻O m_CandicateString.clear();
	}	

	StringList.Clear();
	return b_ret;
}
/*
bool PPbopomo::CimConfigure(wchar_t *pRootChar)
{
	CUnicodeStringList StringList;
	size_t n = 0;	
	bool b_ret = false;

	// 1. get available roots. oҦr
	m_cim.GetAvailableRoots(pRootChar, false, &StringList);

	// 2. get number of available roots. 
	n = m_cim.GetCountOfAvailableRoots(&StringList);
	
	if(n>0)
	{
		//there are other word roots.
		if(m_pRootString != NULL)
		{
			delete [] m_pRootString;
			m_pRootString = NULL;
		}
		m_pRootString = new wchar_t[n+1];	// zero ending string.
		
		// 3. get wide character array. 
		m_cim.GetAvailableRootsArray(&StringList, m_pRootString, n+1);
		b_ret = true;
	}
	else
	{				
		m_cim.GetCandidateWordsByRoot(pRootChar, false, &m_pCI);
		size_t count = m_cim.GetCountOfCandidateWords(m_pCI);

		if(count > 0)
		{
			m_pCWBuffer = new CandidateWordBuffer[count];
	
			if(m_pCWBuffer)
			{
				m_cim.SortCandidateWords(m_pCI, DES_BY_PRIORITY);
				m_cim.GetCandidateWordsArray(m_pCI, m_pCWBuffer, count);
			}
		}

		if(m_pCWBuffer != NULL)
		{
			memset(m_CandicateString, 0, sizeof(m_CandicateString)); //쥻O m_CandicateString.clear();
			wchar_t wctemp[CANDIDATEWORD_BUFFER_SIZE];
			
			for(size_t i=0; i<count; i++)
			{			
				//쥻O m_CandicateString.push_back(m_pCWBuffer[i].CandidateWord[0]);
				memset(wctemp, 0, sizeof(wctemp));
				*wctemp = m_pCWBuffer[i].CandidateWord[0];
				wcscat(m_CandicateString, wctemp);
			}
		}

		if(m_pRootString != NULL)
		{
			delete [] m_pRootString;
			m_pRootString = NULL;
		}
		b_ret = true;
	}
		
	StringList.Clear();
	return b_ret;
}
*/
int PPbopomo::GetPreeditStringLen()
{
	g_message("Preedit Len: %d", wcslen(m_PreeditString));
	return wcslen(m_PreeditString);
}


int PPbopomo::CandicateStringLen()
{
	g_message("Preedit Len: %d", wcslen(m_CandicateString));
	return wcslen(m_CandicateString);
}

bool PPbopomo::Inintial(char * dbpath, char * dbprioritypath)
{
	if(m_cim.LoadCTB(dbpath) && m_cim.LoadPriorities(dbprioritypath))
	{
		return true;
	}
	
	return false;
}

bool PPbopomo::CheckIsSound(wchar_t *pstr)
{
	if(pstr)
	{
		wchar_t wc3[]=L"ˇ";
		wchar_t wc4[]=L"ˋ";
		wchar_t wc2[]=L"ˊ";
		wchar_t wc5[]=L"˙";
		
		if( (wcscmp(pstr, wc3) == 0) ||
			(wcscmp(pstr, wc4) == 0) ||
			(wcscmp(pstr, wc2) == 0) ||
			(wcscmp(pstr, wc5) == 0)  )
		{
			//g_message("Is Sound !!");
			return true;
		}
	
	}

	return false;
}

bool PPbopomo::SelectCandidate(wchar_t wch)
{
	bool result;
	if(m_pCWBuffer)
	{
		CandidateWordBuffer aCandidateWord;
		int wlen = wcslen(m_CandicateString); 
		for(int i = 0; i < wlen;i++)
		{
			if(wch == m_CandicateString[i])
			{
				result = m_cim.SelectCandidateWord(m_pCI, m_pCWBuffer[i].ID, &aCandidateWord);
				i = wlen;
			}
		}
	}

	return result;
}

///////////////////////////// flie end /////////////////////////////
